package it.unibo.stradivarius.database;

import android.database.Cursor;
import androidx.room.EntityDeletionOrUpdateAdapter;
import androidx.room.EntityInsertionAdapter;
import androidx.room.RoomDatabase;
import androidx.room.RoomSQLiteQuery;
import androidx.room.util.CursorUtil;
import androidx.room.util.DBUtil;
import androidx.sqlite.db.SupportSQLiteStatement;
import java.lang.Override;
import java.lang.String;
import java.lang.SuppressWarnings;
import java.util.ArrayList;
import java.util.List;

@SuppressWarnings({"unchecked", "deprecation"})
public final class GradesDao_Impl implements GradesDao {
  private final RoomDatabase __db;

  private final EntityInsertionAdapter<Grades> __insertionAdapterOfGrades;

  private final EntityDeletionOrUpdateAdapter<Grades> __deletionAdapterOfGrades;

  public GradesDao_Impl(RoomDatabase __db) {
    this.__db = __db;
    this.__insertionAdapterOfGrades = new EntityInsertionAdapter<Grades>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR ABORT INTO `Grades` (`_id`,`firstName`,`secondName`,`class`,`grade`) VALUES (nullif(?, 0),?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, Grades value) {
        stmt.bindLong(1, value._id);
        if (value.firstName == null) {
          stmt.bindNull(2);
        } else {
          stmt.bindString(2, value.firstName);
        }
        if (value.secondName == null) {
          stmt.bindNull(3);
        } else {
          stmt.bindString(3, value.secondName);
        }
        if (value.class_field == null) {
          stmt.bindNull(4);
        } else {
          stmt.bindString(4, value.class_field);
        }
        stmt.bindLong(5, value.grade);
      }
    };
    this.__deletionAdapterOfGrades = new EntityDeletionOrUpdateAdapter<Grades>(__db) {
      @Override
      public String createQuery() {
        return "DELETE FROM `Grades` WHERE `_id` = ?";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, Grades value) {
        stmt.bindLong(1, value._id);
      }
    };
  }

  @Override
  public void insertNew(final Grades... users) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      __insertionAdapterOfGrades.insert(users);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public void delete(final Grades grades) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      __deletionAdapterOfGrades.handle(grades);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public List<Grades> getAll() {
    final String _sql = "SELECT * FROM Grades";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    __db.assertNotSuspendingTransaction();
    final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
    try {
      final int _cursorIndexOfId = CursorUtil.getColumnIndexOrThrow(_cursor, "_id");
      final int _cursorIndexOfFirstName = CursorUtil.getColumnIndexOrThrow(_cursor, "firstName");
      final int _cursorIndexOfSecondName = CursorUtil.getColumnIndexOrThrow(_cursor, "secondName");
      final int _cursorIndexOfClassField = CursorUtil.getColumnIndexOrThrow(_cursor, "class");
      final int _cursorIndexOfGrade = CursorUtil.getColumnIndexOrThrow(_cursor, "grade");
      final List<Grades> _result = new ArrayList<Grades>(_cursor.getCount());
      while(_cursor.moveToNext()) {
        final Grades _item;
        _item = new Grades();
        _item._id = _cursor.getInt(_cursorIndexOfId);
        _item.firstName = _cursor.getString(_cursorIndexOfFirstName);
        _item.secondName = _cursor.getString(_cursorIndexOfSecondName);
        _item.class_field = _cursor.getString(_cursorIndexOfClassField);
        _item.grade = _cursor.getInt(_cursorIndexOfGrade);
        _result.add(_item);
      }
      return _result;
    } finally {
      _cursor.close();
      _statement.release();
    }
  }

  @Override
  public List<Grades> getThirty() {
    final String _sql = "SELECT * FROM Grades WHERE grade = 30";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    __db.assertNotSuspendingTransaction();
    final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
    try {
      final int _cursorIndexOfId = CursorUtil.getColumnIndexOrThrow(_cursor, "_id");
      final int _cursorIndexOfFirstName = CursorUtil.getColumnIndexOrThrow(_cursor, "firstName");
      final int _cursorIndexOfSecondName = CursorUtil.getColumnIndexOrThrow(_cursor, "secondName");
      final int _cursorIndexOfClassField = CursorUtil.getColumnIndexOrThrow(_cursor, "class");
      final int _cursorIndexOfGrade = CursorUtil.getColumnIndexOrThrow(_cursor, "grade");
      final List<Grades> _result = new ArrayList<Grades>(_cursor.getCount());
      while(_cursor.moveToNext()) {
        final Grades _item;
        _item = new Grades();
        _item._id = _cursor.getInt(_cursorIndexOfId);
        _item.firstName = _cursor.getString(_cursorIndexOfFirstName);
        _item.secondName = _cursor.getString(_cursorIndexOfSecondName);
        _item.class_field = _cursor.getString(_cursorIndexOfClassField);
        _item.grade = _cursor.getInt(_cursorIndexOfGrade);
        _result.add(_item);
      }
      return _result;
    } finally {
      _cursor.close();
      _statement.release();
    }
  }
}
