package it.unibo.stradivarius.database;

import androidx.appcompat.app.AppCompatActivity;
import androidx.room.Room;

import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.text.Html;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

import java.util.List;

public class MainActivity extends AppCompatActivity {

    public static AppDatabase db;

    /**
     * Called when the activity is first created.
     */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        TextView tvMain = findViewById(R.id.tv_main);
        tvMain.setText(Html.fromHtml("Welcome in my <b>Database</b> application. Below, you can see all the students <i>registered</i> in the database. <br><br>"
                + "Pressing <b>MENU</b> will give you some more options"));

        db = Room.databaseBuilder(getApplicationContext(),
                AppDatabase.class, "grades2.db").allowMainThreadQueries().build();
    }

    @Override
    protected void onResume() {
        super.onResume();
        updateList();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        Intent add = new Intent(this, AddStudent.class);
        menu.add("Add Student").setIntent(add);

        Intent t = new Intent(this, Thirty.class);
        menu.add("Show 30's").setIntent(t);

        return true;
    }

    public static AppDatabase getDatabase() {
        return db;
    }

    public void updateList() {
        LinearLayout ll = findViewById(R.id.mainLayout);

        List<Grades> grades = db.gradesDao().getAll();
        int counter;

        for (counter = 0; counter < grades.size(); counter++) {
            TextView tv = new TextView(this);
            ViewGroup.LayoutParams lp = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT);
            tv.setLayoutParams(lp);

            LinearLayout newLL = new LinearLayout(this);
            ViewGroup.LayoutParams newLP = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
            newLL.setLayoutParams(newLP);
            newLL.setOrientation(LinearLayout.HORIZONTAL);

            Grades newGrade = grades.get(counter);

            boolean haveToContinue = false;
            int id = newGrade._id;
            for (int i = 0; i < ll.getChildCount(); i++) {
                if (id == ll.getChildAt(i).getId()) {
                    // We already added this view
                    haveToContinue = true;
                    Log.v("MY", "DUPLICATE");
                } else {
                    Log.v("MY", String.valueOf(ll.getChildAt(i).getId()));
                }
            }
            if (!haveToContinue) {
                newLL.setId(id);
                String firstName = newGrade.firstName;
                String lastName = newGrade.secondName;
                String className = newGrade.class_field;
                int grade = newGrade.grade;

                String toWrite = firstName + " " + lastName + " - " + className + " - " + grade;

                tv.setId(id);

                tv.setText(toWrite);

                newLL.addView(tv);

                Button btn = new Button(this);
                btn.setBackgroundResource(R.color.colorAccent);
                btn.setPadding(0, 0, 0, 0);

                btn.setText("Delete");
                btn.setId(id);
                btn.setLayoutParams(lp);

                btn.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        // NEED THE WHOLE OBJECT HERE
                    }
                });

                newLL.addView(btn);

                ll.addView(newLL);
            }

        }

    }

}