package it.unibo.stradivarius.database;

import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.text.Html;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import java.util.List;

public class Thirty extends AppCompatActivity {

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        TextView tvMain = findViewById(R.id.tv_main);
        tvMain.setText(Html.fromHtml("Below you see all the students that got 30 in any course"));

        AppDatabase supportDB = MainActivity.getDatabase();

        LinearLayout ll = findViewById(R.id.mainLayout);

        List<Grades> grades = supportDB.gradesDao().getThirty();
        int counter;

        for (counter = 0; counter < grades.size(); counter++) {
            TextView tv = new TextView(this);
            ViewGroup.LayoutParams lp = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT);
            tv.setLayoutParams(lp);

            LinearLayout newLL = new LinearLayout(this);
            ViewGroup.LayoutParams newLP = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
            newLL.setLayoutParams(newLP);
            newLL.setOrientation(LinearLayout.HORIZONTAL);

            Grades newGrade = grades.get(counter);

            boolean haveToContinue = false;
            int id = newGrade._id;
            for (int i = 0; i < ll.getChildCount(); i++) {
                if (id == ll.getChildAt(i).getId()) {
                    // We already added this view
                    haveToContinue = true;
                    Log.v("MY", "DUPLICATE");
                } else {
                    Log.v("MY", String.valueOf(ll.getChildAt(i).getId()));
                }
            }
            if (!haveToContinue) {
                newLL.setId(id);
                String firstName = newGrade.firstName;
                String lastName = newGrade.secondName;
                String className = newGrade.class_field;
                int grade = newGrade.grade;

                String toWrite = firstName + " " + lastName + " - " + className + " - " + grade;

                tv.setId(id);

                tv.setText(toWrite);

                newLL.addView(tv);

                Button btn = new Button(this);
                btn.setBackgroundResource(R.color.colorAccent);
                btn.setPadding(0, 0, 0, 0);

                btn.setText("Delete");
                btn.setId(id);
                btn.setLayoutParams(lp);

                btn.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        // NEED THE WHOLE OBJECT HERE
                    }
                });

                newLL.addView(btn);

                ll.addView(newLL);
            }

        }
    }
}
